#ifndef __SPECTRATASKHANDLER_H
#define __SPECTRATASKHANDLER_H

#include "TaskHandler.h"

class Database;
class ItemSet;

// Does things related to pattern sampling, counting & estimation.

class SpectraTH : public TaskHandler {
public:
	SpectraTH (Config *conf);
	virtual ~SpectraTH ();

	virtual void HandleTask();
	virtual string BuildWorkingDir();

protected:
	// Implements both FastEst and Spectra
	void	EstimateNumPatterns();
	
	// Estimate the number of expected frequent patterns under the assumption that all items are independent
	void	EstimateNumExpectedPatternsIndependent();

	// Closed adaptation of FastEst (C-FE)
	void	EstimateNumClosedPatterns();

	// --- Helper ---
	bool	IsClosed(Database *db, ItemSet *parent, ItemSet *cand);

};
#endif // __SPECTRATASKHANDLER_H
